﻿'releasing Com-Objects must be done by Marshal.Release. Otherwise serious Resoruce-Leaks occur.
'access to Com-Object-Properties require Strict Off (dynamic in c#)
Option Strict Off

Imports System.Windows.Forms
Imports System.IO
Imports System.Diagnostics
Imports System.Runtime.InteropServices
Imports System.ComponentModel


<System.ComponentModel.DesignerCategory("Code")>
Public Class FolderView

	Private _ActiveXInstance As Object        ' the Browser-com-Instance, which is wrapped in the WebBrowser-Control
	Private _ShellfolderView As Shell32.IShellFolderViewDual3      ' a specific document, coming up, if the Browser navigates to FileSystem instead of Internet

	Public Sub New()
		InitializeComponent()
		With WebBrowser1
			_ActiveXInstance = .ActiveXInstance
			.AllowNavigation = False
			.AllowWebBrowserDrop = True
			.WebBrowserShortcutsEnabled = True
			.IsWebBrowserContextMenuEnabled = True
		End With
	End Sub

	Protected Overrides Sub Dispose(disposing As Boolean)
		'first dispose as usual, then ReleaseComObjects
		If disposing AndAlso components IsNot Nothing Then components.Dispose() : components = Nothing
		MyBase.Dispose(disposing)
		If disposing Then Marshal.FinalReleaseComObject(_ActiveXInstance)
	End Sub

	Private Sub WebBrowser1_DocumentCompleted(sender As Object, e As WebBrowserDocumentCompletedEventArgs) Handles WebBrowser1.DocumentCompleted
		If _ShellfolderView IsNot Nothing Then Marshal.FinalReleaseComObject(_ShellfolderView)
		_ShellfolderView = TryCast(_ActiveXInstance.document, Shell32.IShellFolderViewDual3)
		If _ShellfolderView IsNot Nothing Then _ShellfolderView.CurrentViewMode = _Viewmode
		WebBrowser1.AllowNavigation = False
	End Sub

	Private _Path As String
	'DesignerSerializationVisibility.Hidden prevents the Form-Designer to generate Code for this Property
	<DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
	Public Property Path() As String
		Get
			Return _Path
		End Get
		Set(value As String)
			If (value <> "") Then value = System.IO.Path.GetFullPath(value).ToLower
			If _Path = value Then Return
			_Path = value
			With WebBrowser1
				.AllowNavigation = True
				WebBrowser1.Navigate(_Path)
			End With
		End Set
	End Property

	Public Enum View : Symbol = 1 : List = 3 : Details = 4 : Tiles = 8 : biggerTiles = 6 : End Enum '  maybe depends on Window-Version

	Private _Viewmode As Integer = 3
	<DefaultValue(3)>
	Public Property Viewmode() As Integer
		Get
			Return _Viewmode
		End Get
		Set(ByVal value As Integer)
			'If Not [Enum].IsDefined(GetType(View), value) Then Return
			If _Viewmode = value Then Return
			_Viewmode = value
			If _ShellfolderView IsNot Nothing Then _ShellfolderView.CurrentViewMode = _Viewmode
		End Set
	End Property


#If False Then
   <DefaultValue(3)>
   Public Property Viewmode() As Integer
      Get
         Return _ShellfolderView.CurrentViewMode
      End Get
      Set(ByVal value As Integer)
         'If Not [Enum].IsDefined(GetType(View), value) Then Return
         If _ShellfolderView Is Nothing Then Return
         If _ShellfolderView.CurrentViewMode = value Then Return
         _ShellfolderView.CurrentViewMode = value
      End Set
   End Property

#End If

End Class
